
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 450
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_ARB_shader_draw_parameters : require
#extension GL_ARB_shader_ballot : require

out float gl_ClipDistance[1];

invariant gl_Position;

struct unaligned_float3
{
    float x;
    float y;
    float z;
};

struct S_TBN
{
    int _iNormal;
    int _iTangent;
};

struct S_INDICES
{
    uint _uiObjectIndex;
    uint _uiMaterialIndex;
    uint _uiMaterialInstanceIndex;
    uint _uiLastFrameMaterialIndex;
    uint _uiLastFrameMaterialInstanceIndex;
    uint _uiPositionsBufferIndex;
    uint _uiPrevPositionsBufferIndex;
    uint _uiNormalsBufferIndex;
    uint _uiPositionOffset;
    uint _uiPrevPositionOffset;
    uint _uiNormalOffset;
    uint _uiMatricesIndex;
};

struct S_MAIN_DEFAULT
{
    S_INDICES _Indices;
};

struct S_MAIN_DEFAULT_ARRAY
{
    S_MAIN_DEFAULT _aMain[32];
};

struct S_MESH_OBJECT
{
    mat4 _mModel;
    mat4 _mModelLast;
    mat4 _mInvModel;
    mat4 _mInvModelLast;
    vec4 _vDiversityOffset;
    uint _uiSceneZoneIndex;
    uint _uiNeighborSceneZoneIndex;
    uint _uiDisplayFlags;
    uint _uiPackedLocalExposureCompensation;
    vec4 _vPortalDirAndDistance;
    int _iPickingID[2];
    float _fLocalExposureCompensation;
    float _fLocalExposureCompensationEV100;
};

struct S_MATERIAL
{
    vec4 _vErrorColor;
    float _fDepthBias;
    float _fDummy0;
    float _fDummy1;
    float _fDummy2;
    float c0;
    float c1;
    float c2;
    float c3;
    uint s0;
    uint s1;
    uint s2;
    uint s3;
    uint s4;
    uint s5;
    uint s6;
    uint s7;
    uint s8;
    uint s9;
    uint s10;
    uint s11;
};

struct S_MATERIAL_INSTANCE
{
    float c0;
    float c1;
    float c2;
    float c3;
    float c4;
    float c5;
    float c6;
    float c7;
    float _fGloubiboulga;
};

struct S_PASS_MATRICES
{
    mat4 _mViewJitteredProj;
    mat4 _mViewProj;
    mat4 _mView;
    mat4 _mInvView;
    mat4 _mJitteredProj;
};

struct S_EYE_DATA
{
    S_PASS_MATRICES _mCurrentFrameMatrices[2];
    S_PASS_MATRICES _mPreviousFrameMatrices[2];
    mat4 _mJitteredProjection[2];
    mat4 _mNoJitterProjection[2];
    mat4 _mInvViewJitteredProj[2];
    vec4 _vWorldSpaceCameraVector[2];
    vec4 _vWorldSpaceCameraPosition[2];
    vec4 _vFrameBufferScale;
    vec4 _vFrameBufferViewportSize;
    vec4 _vFrameBufferOneOnViewportSize;
    vec4 _vViewportSize;
    vec4 _vFogSubCrop;
    uint _uiAlignment0;
    uint _uiAlignment1;
    float _vCameraJitterDeltaX;
    float _vCameraJitterDeltaY;
    vec4 _vfRcpFVolumetricFogDepthTileSize;
};

struct S_CASCADED_SHADOW
{
    mat4 _mCascadeMatrix[2][8];
    mat4 _mViewSpaceToStaticShadowMapSpace[2];
    vec4 _vfCascadeShadowAttenuation;
    vec4 _vfShadowCascadeTextureTexelSize;
    vec4 _vfStaticShadowBlurRadius;
    vec4 _vfCascadeLinearZProjFactors[8];
    vec4 _vfCascadeParams[8];
};

struct S_CLUSTER_LIGHT_SETUP
{
    S_CASCADED_SHADOW _CascadedShadow;
    vec4 _vfSkinUVParamsAndNormalBias;
    vec4 _vfShadowTextureTexelSize;
    vec4 _vfDummy_SkinFresnelF0AndF90;
    uint _uiCascadedUsed;
    float _fSSSWidth;
    float _fOffsetBias;
    float _fDummy;
};

struct S_CLUSTER_INFO
{
    mat4 _mViewToClusterView[2];
    mat4 _mClusterProjMatrix;
    mat4 _mClusterInvProjMatrix;
    vec4 _vfLeftEyeToCombinedEyeVsDeltaXZ;
    uint _uiFinestMipWidth;
    uint _uiFinestMipHeight;
    uint _uiFinestMipDepth;
    uint _uiFinestMipWidthHeight;
    float _fZSliceGeomFactor;
    float _fRcpLogZSliceGeomFactor;
    float _fDummy0;
    float _fDummy1;
    float _fNearP;
    float _fInvNearP;
    float _fFarP;
    float _fClusterCoincidentWithCamera;
};

struct S_PASS
{
    S_EYE_DATA _EyeData;
    vec4 _avFrustumCorners[4];
    vec4 _vTime;
    vec4 _cFogColor;
    vec4 _vFogSetup;
    vec4 _cSunColor;
    vec4 _vSunDir;
    vec4 _vProjectionSetup;
    vec4 _vProjectionCoeff;
    vec4 _vOutputColor;
    vec4 _vfVsClippingPlane[2];
    S_CLUSTER_LIGHT_SETUP _LightSetup;
    S_CLUSTER_INFO _ClusterInfo;
    float _fIBLIntensity;
    float _fGIIntensity;
    float _fAmbiantOcclusionDirectIntensity;
    float _fAmbiantOcclusionIndirectIntensity;
    float _fNormalSign;
    int _iFogType;
    float _fSelfOcclusionDebugRatio;
    float _fEmissive;
    int _iEnableSkinSSSSS;
    int _iUseHairOpaquePrepass;
    float _fLocalSceneExposure;
    uint _uiDebugMode;
    uint _sFlags;
    float _fTAADropsSharpness;
    uint _uNeoScaleX;
    uint _uNeoScaleY;
    uint _uiDirectOverdrawFilter;
    float _fCoderTest0;
    float _fCoderTest1;
    float _fCoderTest2;
    uint _uiBakeOutput;
    float _fDefaultAmbientIntensity;
    float _fDefaultLightingIntensity;
    uint _uiOutputColor;
    float _fAARotation;
    float _fClampDirectSpecular;
    float _fNearPlane;
    float _fFarPlane;
    float _fNDFFilteringScreenSpaceVariance;
    float _fNDFFilteringThreshold;
    float _fNDFFilteringScreenSpaceVariance_EyeShader;
    float _fNDFFilteringThreshold_EyeShader;
    float _fSurfaceGradientTextureFiltering;
    float _fZero;
    uint _uDepthClamp;
    uint _uiLightDebugMode;
    vec4 _vfFragCoordToDepthTexFactor;
    vec4 _vfFragCoordToDepthTexFactor_HalfRes;
    uint _uHdr;
    uint _uiDrawMayaSwatch;
    float _fEyeRoughnessBias;
    float _fDummy1;
};

layout(set = 1, binding = 39, std430) readonly buffer g_rbVertices_Layout
{
    unaligned_float3 g_rbVertices[];
} g_rbVertices_Buffer[];

layout(set = 1, binding = 40, std430) readonly buffer g_rbTBNs_Layout
{
    S_TBN g_rbTBNs[];
} g_rbTBNs_Buffer[];

layout(set = 0, binding = 52, std140) uniform dyn_CONSTANT_BUFFER_BLOCK_CB_S_MAIN_ARRAY_BINDING
{
    S_MAIN_DEFAULT_ARRAY g_cbMainArray;
} _1159;

layout(set = 1, binding = 33, std430) readonly buffer g_rbObjects_Layout
{
    S_MESH_OBJECT g_rbObjects[];
} g_rbObjects_Buffer[];

layout(set = 1, binding = 34, std430) readonly buffer g_rbMaterials_Layout
{
    S_MATERIAL g_rbMaterials[];
} g_rbMaterials_Buffer[];

layout(set = 1, binding = 35, std430) readonly buffer g_rbMaterialInstances_Layout
{
    S_MATERIAL_INSTANCE g_rbMaterialInstances[];
} g_rbMaterialInstances_Buffer[];

layout(set = 2, binding = 53, std140) uniform dyn_CONSTANT_BUFFER_BLOCK_CB_S_PASS_BINDING
{
    S_PASS g_cbPass;
} _1420;

layout(set = 1, binding = 12) uniform sampler2D g_rb2DTextures[];

layout(location = 8) in vec2 in_uv0;
layout(location = 23) out float interp_instanceID;

vec3 _7657;

void main()
{
    int _1149 = gl_InstanceIndex + gl_DrawIDARB;
    int _1150 = readFirstInvocationARB(_1149);
    uint _3086 = uint(gl_VertexIndex);
    uint _3089 = _3086 + _1159.g_cbMainArray._aMain[_1150]._Indices._uiPositionOffset;
    uint _3109 = _3086 + _1159.g_cbMainArray._aMain[_1150]._Indices._uiNormalOffset;
    int _3138 = g_rbTBNs_Buffer[_1159.g_cbMainArray._aMain[_1150]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3109]._iNormal & 1023;
    int _3141 = (g_rbTBNs_Buffer[_1159.g_cbMainArray._aMain[_1150]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3109]._iNormal >> 10) & 1023;
    int _3144 = (g_rbTBNs_Buffer[_1159.g_cbMainArray._aMain[_1150]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3109]._iNormal >> 20) & 1023;
    int _7644;
    if (_3138 > 512)
    {
        _7644 = _3138 | (-1024);
    }
    else
    {
        _7644 = _3138;
    }
    int _7646;
    if (_3141 > 512)
    {
        _7646 = _3141 | (-1024);
    }
    else
    {
        _7646 = _3141;
    }
    int _7648;
    if (_3144 > 512)
    {
        _7648 = _3144 | (-1024);
    }
    else
    {
        _7648 = _3144;
    }
    float _3187 = float(_7644);
    float _3190 = float(_7646);
    float _3193 = float(_7648);
    vec3 _3194 = vec3(_3187, _3190, _3193);
    vec3 _3197 = _3194 * vec3(0.001956947147846221923828125);
    vec4 _3320 = vec4(g_rbVertices_Buffer[_1159.g_cbMainArray._aMain[_1150]._Indices._uiPositionsBufferIndex].g_rbVertices[_3089].x, g_rbVertices_Buffer[_1159.g_cbMainArray._aMain[_1150]._Indices._uiPositionsBufferIndex].g_rbVertices[_3089].y, g_rbVertices_Buffer[_1159.g_cbMainArray._aMain[_1150]._Indices._uiPositionsBufferIndex].g_rbVertices[_3089].z, 1.0);
    vec4 _3321 = g_rbObjects_Buffer[_1159.g_cbMainArray._aMain[_1150]._Indices._uiObjectIndex].g_rbObjects[0]._mModel * _3320;
    vec3 _3322 = _3321.xyz;
    mat3 _3479 = mat3(g_rbObjects_Buffer[_1159.g_cbMainArray._aMain[_1150]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[0].xyz, g_rbObjects_Buffer[_1159.g_cbMainArray._aMain[_1150]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[1].xyz, g_rbObjects_Buffer[_1159.g_cbMainArray._aMain[_1150]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[2].xyz);
    vec3 _3482 = _3479 * _3197;
    vec2 _3686 = in_uv0 * vec2(2.0);
    vec3 _7591 = _7657;
    _7591.y = textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1159.g_cbMainArray._aMain[_1150]._Indices._uiMaterialIndex].g_rbMaterials[0].s0], _3686 + vec2(-0.07500000298023223876953125, -0.60000002384185791015625), 0.0).x;
    vec3 _3704 = vec3(g_rbMaterialInstances_Buffer[_1159.g_cbMainArray._aMain[_1150]._Indices._uiMaterialInstanceIndex].g_rbMaterialInstances[0].c0);
    vec3 _3707 = mod(_3704, vec3(2.0));
    vec3 _3711 = _7591 * _3707;
    vec3 _7600 = _7657;
    _7600.y = textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1159.g_cbMainArray._aMain[_1150]._Indices._uiMaterialIndex].g_rbMaterials[0].s0], _3686 + vec2(-0.800000011920928955078125, 0.0272109992802143096923828125), 0.0).y;
    vec3 _3741 = _3704 * vec3(0.100000001490116119384765625);
    vec3 _3744 = floor(_3741);
    vec3 _3748 = mod(_3744, vec3(2.0));
    vec3 _3752 = _7600 * _3748;
    vec3 _3756 = vec3(1.0) - _3711;
    vec3 _3759 = vec3(1.0) - _3752;
    vec3 _3760 = _3756 * _3759;
    vec3 _7609 = _7657;
    _7609.y = textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1159.g_cbMainArray._aMain[_1150]._Indices._uiMaterialIndex].g_rbMaterials[0].s0], _3686 + vec2(-0.78911602497100830078125, -0.800000011920928955078125), 0.0).z;
    vec3 _3792 = _3704 * vec3(0.00999999977648258209228515625);
    vec3 _3795 = floor(_3792);
    vec3 _3799 = mod(_3795, vec3(2.0));
    vec3 _3803 = _7609 * _3799;
    vec3 _3810 = vec3(1.0) - _3803;
    vec3 _3811 = _3760 * _3810;
    vec3 _3813 = vec3(1.0) - _3811;
    float _3815 = _3813.y;
    float _3820 = _3815 - 0.949999988079071044921875;
    float _3825 = _3820 * 19.9959964752197265625;
    float _3826 = clamp(_3825, 0.0, 1.0);
    float _3827 = mix(0.0, 1.0, _3826);
    float _3835 = _3815 - 0.88999998569488525390625;
    float _3840 = _3835 * 99.90019989013671875;
    float _3841 = clamp(_3840, 0.0, 1.0);
    float _3842 = mix(0.0, 1.0, _3841);
    vec3 _3847 = vec3(_3842);
    vec3 _3848 = mix(vec3(0.0), vec3(-0.011610000394284725189208984375), _3847);
    vec3 _3853 = vec3(_3827);
    vec3 _3854 = mix(_3848, vec3(-0.03869999945163726806640625), _3853);
    vec3 _3860 = _3854 * _3482;
    vec3 _3868 = vec3(g_rbMaterialInstances_Buffer[_1159.g_cbMainArray._aMain[_1150]._Indices._uiMaterialInstanceIndex].g_rbMaterialInstances[0].c1);
    vec3 _3869 = mix(vec3(0.0), _3860, _3868);
    vec3 _3892 = _3322 + _3869;
    float _3957 = _3892.x;
    float _3958 = _3892.y;
    float _3959 = _3892.z;
    vec4 _3960 = vec4(_3957, _3958, _3959, 1.0);
    vec4 _3961 = _1420.g_cbPass._EyeData._mCurrentFrameMatrices[0]._mView * _3960;
    vec4 _3977 = _1420.g_cbPass._EyeData._mCurrentFrameMatrices[0]._mViewJitteredProj * _3960;
    vec4 _7654;
    if (_1420.g_cbPass._uDepthClamp == 4294967295u)
    {
        float _3992 = _3977.w;
        vec4 _7655;
        if ((_3977.z / _3992) > 1.0)
        {
            vec4 _7656;
            if (_3961.z > _1420.g_cbPass._fNearPlane)
            {
                vec4 _7622 = _3977;
                _7622.z = _3992;
                _7656 = _7622;
            }
            else
            {
                _7656 = _3977;
            }
            _7655 = _7656;
        }
        else
        {
            _7655 = _3977;
        }
        _7654 = _7655;
    }
    else
    {
        _7654 = _3977;
    }
    interp_instanceID = float(_1149) + 0.5;
    float _2972 = _3961.x;
    float _2973 = _3961.y;
    float _2974 = _3961.z;
    vec4 _2975 = vec4(_2972, _2973, _2974, 1.0);
    float _2976 = dot(_1420.g_cbPass._vfVsClippingPlane[0], _2975);
    float _2977 = -_2976;
    gl_ClipDistance[0] = _2977;
    gl_Position = _7654;
}

